package jat.managedbeans;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.ValidatorException;
import javax.servlet.http.Part;

import jat.dto.Person;
import jat.fakeDB.PersonDB;

@ManagedBean
@SessionScoped
public class PersonMB {

	@ManagedProperty("#{personDB}")
	private PersonDB personDB;
	private Person edited;
	private Part avatarData;

	public List<Person> getAllPersons() {
		return personDB.getAll();
	}

	public Person getEdited() {
		return edited;
	}

	public void setEdited(Person edited) {
		this.edited = edited;
	}

	public String createNew() {
		edited = new Person();
		return "editPerson";
	}

	public String edit(Person s) {
		edited = s;
		return "editPerson";
	}

	public String delete(Person s) {
		personDB.remove(s.getId());
		return "index";
	}

	public String save() {
		if (edited.getId() == 0) {
			personDB.insert(edited);
		} else {
			personDB.merge(edited);
		}
		return "index";
	}

	public PersonDB getPersonDB() {
		return personDB;
	}

	public void setPersonDB(PersonDB personDB) {
		this.personDB = personDB;
	}

	public Part getAvatarData() {
		return avatarData;
	}

	public void setAvatarData(Part avatarData) {
		this.avatarData = avatarData;
	}

	public String uploadAvatar() {
		byte[] buffer = new byte[(int) avatarData.getSize()];
		try (InputStream inputStream = avatarData.getInputStream()) {
			int readed = inputStream.read(buffer);
			edited.setAvatarImg(buffer);
		} catch (IOException e) {
			// Error handling
		}
		return "";
	}

	public void validateAvatarImage(FacesContext ctx, UIComponent comp, Object value) {
		List<FacesMessage> msgs = new ArrayList<>();
		Part file = (Part) value;
		if (file.getSize() > 1024*50) {
			msgs.add(new FacesMessage("file too big. Max size is " + (1024*50)));
		}
		if (!"image/png".equals(file.getContentType())) {
			msgs.add(new FacesMessage("Must be PNG image."));
		}
		if (!msgs.isEmpty()) {
			throw new ValidatorException(msgs);
		}
	}

}
